Index: ChangeLog
===================================================================
RCS file: /usr/local/CVS/ngircd/ngircd/ChangeLog,v
retrieving revision 1.147.2.3
retrieving revision 1.147.2.13
diff -u -r1.147.2.3 -r1.147.2.13
--- ChangeLog	24 Dec 2002 13:53:54 -0000	1.147.2.3
+++ ChangeLog	21 Jan 2003 21:20:19 -0000	1.147.2.13
@@ -10,6 +10,27 @@
                         -- ChangeLog / Aenderungen --
 
 
+ngIRCd 0.6.1, 2002-01-21
+
+  - Fixed KILL: you can't crash the server by killing yourself any more,
+    ngIRCd no longer sends a QUIT to other servers after the KILL, and you
+    can kill only valid users now.
+  - The server no longer forwards commands to ordinary users, instead it
+    answers with the correct error message ("no such server") now.
+  - WHOIS commands weren't always forwarded as requested.
+  - The server sets a correct default AWAY message now when propagating
+    between servers (bug introduced in 0.6.0).
+  - Fixed up and enhanced CHANINFO command: channel keys and user limits
+    are syncronized between servers now, too.
+  - MODE returns the key and user limit for channel members correctly now.
+  - Non-members of a channel could crash the server when trying to change
+    its modes or modes of its members.
+  - The server didn't validate weather a target user is a valid channel
+    member when changing his channel user modes which could crash ngIRCd.
+
+
+Older changes (sorry, only available in german language):
+
 ngIRCd 0.6.0, 2002-12-24
 
   ngIRCd 0.6.0-pre2, 2002-12-23
@@ -369,4 +390,4 @@
 
 
 -- 
-$Id: ChangeLog,v 1.147.2.3 2002/12/24 13:53:54 alex Exp $
+$Id: ChangeLog,v 1.147.2.13 2003/01/21 21:20:19 alex Exp $
Index: configure.in
===================================================================
RCS file: /usr/local/CVS/ngircd/ngircd/configure.in,v
retrieving revision 1.69.2.3
retrieving revision 1.69.2.5
diff -u -r1.69.2.3 -r1.69.2.5
--- configure.in	24 Dec 2002 13:54:09 -0000	1.69.2.3
+++ configure.in	21 Jan 2003 21:23:34 -0000	1.69.2.5
@@ -1,15 +1,14 @@
 #
 # ngIRCd -- The Next Generation IRC Daemon
-# Copyright (c)2001,2002 by Alexander Barton (alex@barton.de)
+# Copyright (c)2001-2003 by Alexander Barton (alex@barton.de)
 #
-# Dieses Programm ist freie Software. Sie koennen es unter den Bedingungen
-# der GNU General Public License (GPL), wie von der Free Software Foundation
-# herausgegeben, weitergeben und/oder modifizieren, entweder unter Version 2
-# der Lizenz oder (wenn Sie es wuenschen) jeder spaeteren Version.
-# Naehere Informationen entnehmen Sie bitter der Datei COPYING. Eine Liste
-# der an ngIRCd beteiligten Autoren finden Sie in der Datei AUTHORS.
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+# Please read the file COPYING, README and AUTHORS for more information.
 #
-# $Id: configure.in,v 1.69.2.3 2002/12/24 13:54:09 alex Exp $
+# $Id: configure.in,v 1.69.2.5 2003/01/21 21:23:34 alex Exp $
 #
 
 # -- Initialisierung --
@@ -18,7 +17,7 @@
 AC_PREREQ(2.50)
 AC_CANONICAL_TARGET
 AC_CONFIG_SRCDIR(src/config.h.in)
-AM_INIT_AUTOMAKE(ngircd,0.6.0)
+AM_INIT_AUTOMAKE(ngircd,0.6.1)
 AM_CONFIG_HEADER(src/config.h)
 
 # -- Templates fuer config.h --
Index: contrib/ngircd.spec
===================================================================
RCS file: /usr/local/CVS/ngircd/ngircd/contrib/ngircd.spec,v
retrieving revision 1.2.2.3
retrieving revision 1.2.2.5
diff -u -r1.2.2.3 -r1.2.2.5
--- contrib/ngircd.spec	24 Dec 2002 13:54:09 -0000	1.2.2.3
+++ contrib/ngircd.spec	21 Jan 2003 21:23:34 -0000	1.2.2.5
@@ -1,5 +1,5 @@
 %define name    ngircd
-%define version 0.6.0
+%define version 0.6.1
 %define release 1
 %define prefix  %{_prefix}
 
Index: doc/Protocol.txt
===================================================================
RCS file: /usr/local/CVS/ngircd/ngircd/doc/Protocol.txt,v
retrieving revision 1.5
retrieving revision 1.5.4.1
diff -u -r1.5 -r1.5.4.1
--- doc/Protocol.txt	4 Sep 2002 00:06:19 -0000	1.5
+++ doc/Protocol.txt	8 Jan 2003 20:36:57 -0000	1.5.4.1
@@ -90,11 +90,11 @@
 II.2 Channel-Modes, persistente Channel und Topic austauschen
 
      Befehl: CHANINFO
-  Parameter: <channel> +<mode> [<topic>]
+  Parameter: <channel> +<modes> [[<key> <maxusers>] <topic>]
        Fuer: Server
 
 Mit CHANINFO Informiert ein Server den anderen ueber einen Channel: dessen
-Modes und dessen Topic. <topic> ist optional.
+Modes, Channel-Key, User-Limit und dessen Topic. <topic> ist optional.
 
 Existiert auf dem Server, der das CHANINFO empfaengt, der Channel bereits,
 so uebernimmt er die Werte jeweils nur dann, wenn er selber noch keine
@@ -104,6 +104,12 @@
 Existiert der Channel noch nicht, so wird er mit den entsprechenden Angaben
 erzeugt.
 
+Hat ein Channel keinen Key (in <modes> ist der Mode "k" nicht vorhanden),
+so muss der Parameter <key> ignoriert werden (da <key> vorhanden sein muss,
+sollte in diesem Fall "*" uebergeben werden). Hat er kein User-Limit (kein
+"l" in <modes>), so muss <limit> ignoriert werden (<limit> sollte hierbei
+als "0" uebergeben werden).
+
 
 -- 
-$Id: Protocol.txt,v 1.5 2002/09/04 00:06:19 alex Exp $
+$Id: Protocol.txt,v 1.5.4.1 2003/01/08 20:36:57 alex Exp $
Index: src/ngircd/Makefile.am
===================================================================
RCS file: /usr/local/CVS/ngircd/ngircd/src/ngircd/Makefile.am,v
retrieving revision 1.31
retrieving revision 1.31.2.1
diff -u -r1.31 -r1.31.2.1
--- src/ngircd/Makefile.am	12 Dec 2002 12:36:41 -0000	1.31
+++ src/ngircd/Makefile.am	4 Jan 2003 10:58:15 -0000	1.31.2.1
@@ -9,7 +9,7 @@
 # Naehere Informationen entnehmen Sie bitter der Datei COPYING. Eine Liste
 # der an ngIRCd beteiligten Autoren finden Sie in der Datei AUTHORS.
 #
-# $Id: Makefile.am,v 1.31 2002/12/12 12:36:41 alex Exp $
+# $Id: Makefile.am,v 1.31.2.1 2003/01/04 10:58:15 alex Exp $
 #
 
 AUTOMAKE_OPTIONS = ../portab/ansi2knr
@@ -65,7 +65,8 @@
 cvs-date:
 	grep VERSION ../config.h | grep "CVS" \
 	 && echo "#define CVSDATE \"$$( grep "\$$Id" $(srcdir)/*.c \
-	    | awk "{ print \$$9 }" | sort | tail -n 1 )\"" > cvs-version.new \
+	    | $(AWK) "{ print \$$9 }" | sort | tail -1 \
+	    | sed -e "s/\//-/g" )\"" > cvs-version.new \
 	 || echo "" > cvs-version.new
 	diff cvs-version.h cvs-version.new || cp cvs-version.new cvs-version.h
 
Index: src/ngircd/client.c
===================================================================
RCS file: /usr/local/CVS/ngircd/ngircd/src/ngircd/client.c,v
retrieving revision 1.65.2.1
retrieving revision 1.65.2.3
diff -u -r1.65.2.1 -r1.65.2.3
--- src/ngircd/client.c	22 Dec 2002 23:42:28 -0000	1.65.2.1
+++ src/ngircd/client.c	8 Jan 2003 23:13:45 -0000	1.65.2.3
@@ -17,7 +17,7 @@
 
 #include "portab.h"
 
-static char UNUSED id[] = "$Id: client.c,v 1.65.2.1 2002/12/22 23:42:28 alex Exp $";
+static char UNUSED id[] = "$Id: client.c,v 1.65.2.3 2003/01/08 23:13:45 alex Exp $";
 
 #include "imp.h"
 #include <assert.h>
@@ -394,24 +394,14 @@
 GLOBAL VOID
 Client_SetAway( CLIENT *Client, CHAR *Txt )
 {
-	/* Von einem Client gelieferte AWAY-Nachricht */
-
+	/* Set AWAY reason of client */
+	
 	assert( Client != NULL );
+	assert( Txt != NULL );
 
-	if( Txt )
-	{
-		/* Client AWAY setzen */
-		strncpy( Client->away, Txt, CLIENT_AWAY_LEN - 1 );
-		Client->away[CLIENT_AWAY_LEN - 1] = '\0';
-		Client_ModeAdd( Client, 'a' );
-		Log( LOG_DEBUG, "User \"%s\" is away: %s", Client_Mask( Client ), Txt );
-	}
-	else
-	{
-		/* AWAY loeschen */
-		Client_ModeDel( Client, 'a' );
-		Log( LOG_DEBUG, "User \"%s\" is no longer away.", Client_Mask( Client ));
-	}
+	strncpy( Client->away, Txt, CLIENT_AWAY_LEN - 1 );
+	Client->away[CLIENT_AWAY_LEN - 1] = '\0';
+	Log( LOG_DEBUG, "User \"%s\" is away: %s", Client_Mask( Client ), Txt );
 } /* Client_SetAway */
 
 
Index: src/ngircd/irc-channel.c
===================================================================
RCS file: /usr/local/CVS/ngircd/ngircd/src/ngircd/irc-channel.c,v
retrieving revision 1.21
retrieving revision 1.21.2.5
diff -u -r1.21 -r1.21.2.5
--- src/ngircd/irc-channel.c	16 Dec 2002 23:06:46 -0000	1.21
+++ src/ngircd/irc-channel.c	8 Jan 2003 23:09:34 -0000	1.21.2.5
@@ -14,7 +14,7 @@
 
 #include "portab.h"
 
-static char UNUSED id[] = "$Id: irc-channel.c,v 1.21 2002/12/16 23:06:46 alex Exp $";
+static char UNUSED id[] = "$Id: irc-channel.c,v 1.21.2.5 2003/01/08 23:09:34 alex Exp $";
 
 #include "imp.h"
 #include <assert.h>
@@ -326,7 +326,7 @@
 	{
 		/* an anderen Server forwarden */
 		target = Client_Search( Req->argv[1] );
-		if( ! target ) return IRC_WriteStrClient( from, ERR_NOSUCHSERVER_MSG, Client_ID( Client ), Req->argv[1] );
+		if(( ! target ) || ( Client_Type( target ) != CLIENT_SERVER )) return IRC_WriteStrClient( from, ERR_NOSUCHSERVER_MSG, Client_ID( Client ), Req->argv[1] );
 
 		if( target != Client_ThisServer( ))
 		{
@@ -365,18 +365,24 @@
 	CLIENT *from;
 	CHANNEL *chan;
 	CHAR *ptr;
+	INT arg_topic;
 
 	assert( Client != NULL );
 	assert( Req != NULL );
 
-	/* Falsche Anzahl Parameter? */
-	if(( Req->argc < 1 ) || ( Req->argc > 3 )) return IRC_WriteStrClient( Client, ERR_NEEDMOREPARAMS_MSG, Client_ID( Client ), Req->command );
+	/* Bad number of parameters? */
+	if(( Req->argc < 2 ) || ( Req->argc == 4 ) || ( Req->argc > 5 )) return IRC_WriteStrClient( Client, ERR_NEEDMOREPARAMS_MSG, Client_ID( Client ), Req->command );
+
+	/* Compatibility kludge */
+	if( Req->argc == 5 ) arg_topic = 4;
+	else if( Req->argc == 3 ) arg_topic = 2;
+	else arg_topic = -1;
 
-	/* From-Server suchen */
+	/* Search origin */
 	from = Client_Search( Req->prefix );
 	if( ! from ) return IRC_WriteStrClient( Client, ERR_NOSUCHNICK_MSG, Client_ID( Client ), Req->prefix );
 
-	/* Channel suchen bzw. erzeugen */
+	/* Search or create channel */
 	chan = Channel_Search( Req->argv[0] );
 	if( ! chan ) chan = Channel_Create( Req->argv[0] );
 	if( ! chan ) return CONNECTED;
@@ -386,27 +392,36 @@
 		ptr = Channel_Modes( chan );
 		if( ! *ptr )
 		{
-			/* OK, es sind noch keine Modes gesetzt */
+			/* OK, this channel doesn't have modes jet, set the received ones: */
 			Channel_SetModes( chan, &Req->argv[1][1] );
-			IRC_WriteStrChannelPrefix( Client, chan, from, FALSE, "MODE %s +%s", Req->argv[0], &Req->argv[1][1] );
+
+			/* Delete modes which we never want to inherit */
+			Channel_ModeDel( chan, 'l' );
+			Channel_ModeDel( chan, 'k' );
+
+			/* Inform members of this channel */
+			IRC_WriteStrChannelPrefix( Client, chan, from, FALSE, "MODE %s +%s", Req->argv[0], Channel_Modes( chan ));
 		}
 	}
 	else Log( LOG_WARNING, "CHANNELINFO: invalid MODE format ignored!" );
 
-	if( Req->argc == 3 )
+	if( arg_topic > 0 )
 	{
-		/* Es wurde auch ein Topic mit uebermittelt */
+		/* We got a topic */
 		ptr = Channel_Topic( chan );
-		if( ! *ptr )
+		if(( ! *ptr ) && ( Req->argv[arg_topic][0] ))
 		{
-			/* OK, es ist bisher kein Topic gesetzt */
-			Channel_SetTopic( chan, Req->argv[2] );
-			IRC_WriteStrChannelPrefix( Client, chan, from, FALSE, "TOPIC %s :%s", Req->argv[0], Req->argv[2] );
+			/* OK, there is no topic jet */
+			Channel_SetTopic( chan, Req->argv[arg_topic] );
+			IRC_WriteStrChannelPrefix( Client, chan, from, FALSE, "TOPIC %s :%s", Req->argv[0], Channel_Topic( chan ));
 		}
 	}
 
-	/* an andere Server forwarden */
-	IRC_WriteStrServersPrefixFlag( Client, from, 'C', "CHANINFO %s %s :%s", Req->argv[0], Req->argv[1], Req->argv[2] );
+	/* Forward CHANINFO to other serevrs */
+	if( Req->argc == 5 ) IRC_WriteStrServersPrefixFlag( Client, from, 'C', "CHANINFO %s %s %s %s :%s", Req->argv[0], Req->argv[1], Req->argv[2], Req->argv[3], Req->argv[4] );
+	else if( Req->argc == 3 ) IRC_WriteStrServersPrefixFlag( Client, from, 'C', "CHANINFO %s %s :%s", Req->argv[0], Req->argv[1], Req->argv[2] );
+	else IRC_WriteStrServersPrefixFlag( Client, from, 'C', "CHANINFO %s %s", Req->argv[0], Req->argv[1] );
+
 	return CONNECTED;
 } /* IRC_CHANINFO */
 
Index: src/ngircd/irc-info.c
===================================================================
RCS file: /usr/local/CVS/ngircd/ngircd/src/ngircd/irc-info.c,v
retrieving revision 1.8.2.1
retrieving revision 1.8.2.2
diff -u -r1.8.2.1 -r1.8.2.2
--- src/ngircd/irc-info.c	22 Dec 2002 23:42:28 -0000	1.8.2.1
+++ src/ngircd/irc-info.c	1 Jan 2003 13:46:37 -0000	1.8.2.2
@@ -14,7 +14,7 @@
 
 #include "portab.h"
 
-static char UNUSED id[] = "$Id: irc-info.c,v 1.8.2.1 2002/12/22 23:42:28 alex Exp $";
+static char UNUSED id[] = "$Id: irc-info.c,v 1.8.2.2 2003/01/01 13:46:37 alex Exp $";
 
 #include "imp.h"
 #include <assert.h>
@@ -62,7 +62,7 @@
 	/* An anderen Server weiterleiten? */
 	if( target != Client_ThisServer( ))
 	{
-		if( ! target ) return IRC_WriteStrClient( prefix, ERR_NOSUCHSERVER_MSG, Client_ID( prefix ), Req->argv[0] );
+		if(( ! target ) || ( Client_Type( target ) != CLIENT_SERVER )) return IRC_WriteStrClient( prefix, ERR_NOSUCHSERVER_MSG, Client_ID( prefix ), Req->argv[0] );
 
 		/* forwarden */
 		IRC_WriteStrClientPrefix( target, prefix, "ADMIN %s", Req->argv[0] );
@@ -141,7 +141,7 @@
 	if( Req->argc == 2 )
 	{
 		target = Client_Search( Req->argv[0] );
-		if( ! target ) return IRC_WriteStrClient( from, ERR_NOSUCHSERVER_MSG, Client_ID( from ), Req->argv[0] );
+		if(( ! target ) || ( Client_Type( target ) != CLIENT_SERVER )) return IRC_WriteStrClient( from, ERR_NOSUCHSERVER_MSG, Client_ID( from ), Req->argv[0] );
 		else if( target != Client_ThisServer( )) return IRC_WriteStrClientPrefix( target, from, "LINKS %s %s", Req->argv[0], Req->argv[1] );
 	}
 
@@ -184,7 +184,7 @@
 	if( Req->argc == 2 )
 	{
 		target = Client_Search( Req->argv[1] );
-		if( ! target ) return IRC_WriteStrClient( from, ERR_NOSUCHSERVER_MSG, Client_ID( from ), Req->argv[1] );
+		if(( ! target ) || ( Client_Type( target ) != CLIENT_SERVER )) return IRC_WriteStrClient( from, ERR_NOSUCHSERVER_MSG, Client_ID( from ), Req->argv[1] );
 		else if( target != Client_ThisServer( )) return IRC_WriteStrClientPrefix( target, from, "LUSERS %s %s", Req->argv[0], Req->argv[1] );
 	}
 
@@ -219,7 +219,7 @@
 	{
 		/* an anderen Server forwarden */
 		target = Client_Search( Req->argv[0] );
-		if( ! target ) return IRC_WriteStrClient( from, ERR_NOSUCHSERVER_MSG, Client_ID( from ), Req->argv[0] );
+		if(( ! target ) || ( Client_Type( target ) != CLIENT_SERVER )) return IRC_WriteStrClient( from, ERR_NOSUCHSERVER_MSG, Client_ID( from ), Req->argv[0] );
 
 		if( target != Client_ThisServer( ))
 		{
@@ -254,7 +254,7 @@
 	{
 		/* an anderen Server forwarden */
 		target = Client_Search( Req->argv[1] );
-		if( ! target ) return IRC_WriteStrClient( from, ERR_NOSUCHSERVER_MSG, Client_ID( from ), Req->argv[1] );
+		if(( ! target ) || ( Client_Type( target ) != CLIENT_SERVER )) return IRC_WriteStrClient( from, ERR_NOSUCHSERVER_MSG, Client_ID( from ), Req->argv[1] );
 
 		if( target != Client_ThisServer( ))
 		{
@@ -349,7 +349,7 @@
 	{
 		/* an anderen Server forwarden */
 		target = Client_Search( Req->argv[1] );
-		if( ! target ) return IRC_WriteStrClient( from, ERR_NOSUCHSERVER_MSG, Client_ID( from ), Req->argv[1] );
+		if(( ! target ) || ( Client_Type( target ) != CLIENT_SERVER )) return IRC_WriteStrClient( from, ERR_NOSUCHSERVER_MSG, Client_ID( from ), Req->argv[1] );
 
 		if( target != Client_ThisServer( ))
 		{
@@ -426,7 +426,7 @@
 	{
 		/* an anderen Server forwarden */
 		target = Client_Search( Req->argv[0] );
-		if( ! target ) return IRC_WriteStrClient( Client, ERR_NOSUCHSERVER_MSG, Client_ID( Client ), Req->argv[0] );
+		if(( ! target ) || ( Client_Type( target ) != CLIENT_SERVER )) return IRC_WriteStrClient( Client, ERR_NOSUCHSERVER_MSG, Client_ID( Client ), Req->argv[0] );
 
 		if( target != Client_ThisServer( ))
 		{
@@ -504,7 +504,7 @@
 	/* An anderen Server weiterleiten? */
 	if( target != Client_ThisServer( ))
 	{
-		if( ! target ) return IRC_WriteStrClient( prefix, ERR_NOSUCHSERVER_MSG, Client_ID( prefix ), Req->argv[0] );
+		if(( ! target ) || ( Client_Type( target ) != CLIENT_SERVER )) return IRC_WriteStrClient( prefix, ERR_NOSUCHSERVER_MSG, Client_ID( prefix ), Req->argv[0] );
 
 		/* forwarden */
 		IRC_WriteStrClientPrefix( target, prefix, "VERSION %s", Req->argv[0] );
@@ -596,40 +596,39 @@
 IRC_WHOIS( CLIENT *Client, REQUEST *Req )
 {
 	CLIENT *from, *target, *c;
-	CHAR str[LINE_LEN + 1], *ptr = NULL;
+	CHAR str[LINE_LEN + 1];
 	CL2CHAN *cl2chan;
 	CHANNEL *chan;
 
 	assert( Client != NULL );
 	assert( Req != NULL );
 
-	/* Falsche Anzahl Parameter? */
+	/* Bad number of parameters? */
 	if(( Req->argc < 1 ) || ( Req->argc > 2 )) return IRC_WriteStrClient( Client, ERR_NEEDMOREPARAMS_MSG, Client_ID( Client ), Req->command );
 
-	/* Client suchen */
+	/* Search client */
 	c = Client_Search( Req->argv[Req->argc - 1] );
 	if(( ! c ) || ( Client_Type( c ) != CLIENT_USER )) return IRC_WriteStrClient( Client, ERR_NOSUCHNICK_MSG, Client_ID( Client ), Req->argv[Req->argc - 1] );
 
-	/* Empfaenger des WHOIS suchen */
+	/* Search sender of the WHOIS */
 	if( Client_Type( Client ) == CLIENT_SERVER ) from = Client_Search( Req->prefix );
 	else from = Client;
 	if( ! from ) return IRC_WriteStrClient( Client, ERR_NOSUCHNICK_MSG, Client_ID( Client ), Req->prefix );
 
-	/* Forwarden an anderen Server? */
+	/* Forward to other server? */
 	if( Req->argc > 1 )
 	{
-		/* angegebenen Ziel-Server suchen */
-		target = Client_Search( Req->argv[1] );
-		if( ! target ) return IRC_WriteStrClient( from, ERR_NOSUCHSERVER_MSG, Client_ID( from ), Req->argv[1] );
-		ptr = Req->argv[1];
+		/* Search target server (can be specified as nick of that server!) */
+		target = Client_Search( Req->argv[0] );
+		if( ! target ) return IRC_WriteStrClient( from, ERR_NOSUCHSERVER_MSG, Client_ID( from ), Req->argv[0] );
 	}
 	else target = Client_ThisServer( );
 
 	assert( target != NULL );
 
-	if(( Client_NextHop( target ) != Client_ThisServer( )) && ( Client_Type( Client_NextHop( target )) == CLIENT_SERVER )) return IRC_WriteStrClientPrefix( target, from, "WHOIS %s :%s", Req->argv[0], ptr );
+	if(( Client_NextHop( target ) != Client_ThisServer( )) && ( Client_Type( Client_NextHop( target )) == CLIENT_SERVER )) return IRC_WriteStrClientPrefix( target, from, "WHOIS %s :%s", Req->argv[0], Req->argv[1] );
 
-	/* Nick, User und Name */
+	/* Nick, user and name */
 	if( ! IRC_WriteStrClient( from, RPL_WHOISUSER_MSG, Client_ID( from ), Client_ID( c ), Client_User( c ), Client_Hostname( c ), Client_Info( c ))) return DISCONNECTED;
 
 	/* Server */
@@ -643,7 +642,7 @@
 		chan = Channel_GetChannel( cl2chan );
 		assert( chan != NULL );
 
-		/* Channel-Name anhaengen */
+		/* Concatenate channel names */
 		if( str[strlen( str ) - 1] != ':' ) strcat( str, " " );
 		if( strchr( Channel_UserModes( chan, c ), 'o' )) strcat( str, "@" );
 		else if( strchr( Channel_UserModes( chan, c ), 'v' )) strcat( str, "+" );
@@ -651,17 +650,17 @@
 
 		if( strlen( str ) > ( LINE_LEN - CHANNEL_NAME_LEN - 4 ))
 		{
-			/* Zeile wird zu lang: senden! */
+			/* Line becomes too long: send it! */
 			if( ! IRC_WriteStrClient( Client, "%s", str )) return DISCONNECTED;
 			sprintf( str, RPL_WHOISCHANNELS_MSG, Client_ID( from ), Client_ID( c ));
 		}
 
-		/* naechstes Mitglied suchen */
+		/* next */
 		cl2chan = Channel_NextChannelOf( c, cl2chan );
 	}
 	if( str[strlen( str ) - 1] != ':')
 	{
-		/* Es sind noch Daten da, die gesendet werden muessen */
+		/* There is data left to send: */
 		if( ! IRC_WriteStrClient( Client, "%s", str )) return DISCONNECTED;
 	}
 
@@ -671,7 +670,7 @@
 		if( ! IRC_WriteStrClient( from, RPL_WHOISOPERATOR_MSG, Client_ID( from ), Client_ID( c ))) return DISCONNECTED;
 	}
 
-	/* Idle (nur lokale Clients) */
+	/* Idle (only local clients) */
 	if( Client_Conn( c ) > NONE )
 	{
 		if( ! IRC_WriteStrClient( from, RPL_WHOISIDLE_MSG, Client_ID( from ), Client_ID( c ), Conn_GetIdle( Client_Conn ( c )))) return DISCONNECTED;
Index: src/ngircd/irc-login.c
===================================================================
RCS file: /usr/local/CVS/ngircd/ngircd/src/ngircd/irc-login.c,v
retrieving revision 1.27.2.1
retrieving revision 1.27.2.2
diff -u -r1.27.2.1 -r1.27.2.2
--- src/ngircd/irc-login.c	22 Dec 2002 23:42:28 -0000	1.27.2.1
+++ src/ngircd/irc-login.c	1 Jan 2003 13:46:37 -0000	1.27.2.2
@@ -14,7 +14,7 @@
 
 #include "portab.h"
 
-static char UNUSED id[] = "$Id: irc-login.c,v 1.27.2.1 2002/12/22 23:42:28 alex Exp $";
+static char UNUSED id[] = "$Id: irc-login.c,v 1.27.2.2 2003/01/01 13:46:37 alex Exp $";
 
 #include "imp.h"
 #include <assert.h>
@@ -371,7 +371,7 @@
 	{
 		/* es wurde ein Ziel-Client angegeben */
 		target = Client_Search( Req->argv[1] );
-		if( ! target ) return IRC_WriteStrClient( Client, ERR_NOSUCHSERVER_MSG, Client_ID( Client ), Req->argv[1] );
+		if(( ! target ) || ( Client_Type( target ) != CLIENT_SERVER )) return IRC_WriteStrClient( Client, ERR_NOSUCHSERVER_MSG, Client_ID( Client ), Req->argv[1] );
 		if( target != Client_ThisServer( ))
 		{
 			/* ok, forwarden */
@@ -403,7 +403,7 @@
 	if( Req->argc == 2 )
 	{
 		target = Client_Search( Req->argv[1] );
-		if( ! target ) return IRC_WriteStrClient( Client, ERR_NOSUCHSERVER_MSG, Client_ID( Client ), Req->argv[1] );
+		if(( ! target ) || ( Client_Type( target ) != CLIENT_SERVER )) return IRC_WriteStrClient( Client, ERR_NOSUCHSERVER_MSG, Client_ID( Client ), Req->argv[1] );
 		if( target != Client_ThisServer( ))
 		{
 			/* ok, forwarden */
Index: src/ngircd/irc-mode.c
===================================================================
RCS file: /usr/local/CVS/ngircd/ngircd/src/ngircd/irc-mode.c,v
retrieving revision 1.24
retrieving revision 1.24.2.5
diff -u -r1.24 -r1.24.2.5
--- src/ngircd/irc-mode.c	18 Dec 2002 14:16:21 -0000	1.24
+++ src/ngircd/irc-mode.c	21 Jan 2003 21:05:19 -0000	1.24.2.5
@@ -14,7 +14,7 @@
 
 #include "portab.h"
 
-static char UNUSED id[] = "$Id: irc-mode.c,v 1.24 2002/12/18 14:16:21 alex Exp $";
+static char UNUSED id[] = "$Id: irc-mode.c,v 1.24.2.5 2003/01/21 21:05:19 alex Exp $";
 
 #include "imp.h"
 #include <assert.h>
@@ -156,7 +156,11 @@
 		{
 			case 'a':
 				/* Away */
-				if( Client_Type( Client ) == CLIENT_SERVER ) x[0] = 'a';
+				if( Client_Type( Client ) == CLIENT_SERVER )
+				{
+					x[0] = 'a';
+					Client_SetAway( Client, DEFAULT_AWAY_MSG );
+				}
 				else ok = IRC_WriteStrClient( Origin, ERR_NOPRIVILEGES_MSG, Client_ID( Origin ));
 				break;
 			case 'i':
@@ -242,11 +246,42 @@
 	LONG l;
 
 	/* Mode request: let's answer it :-) */
-	if( Req->argc == 1 ) return IRC_WriteStrClient( Origin, RPL_CHANNELMODEIS_MSG, Client_ID( Origin ), Channel_Name( Channel ), Channel_Modes( Channel ));
+	if( Req->argc == 1 )
+	{
+		/* Member or not? -- That's the question! */
+		if( ! Channel_IsMemberOf( Channel, Origin )) return IRC_WriteStrClient( Origin, RPL_CHANNELMODEIS_MSG, Client_ID( Origin ), Channel_Name( Channel ), Channel_Modes( Channel ));
+
+		/* The sender is a member: generate extended reply */
+		strcpy( the_modes, Channel_Modes( Channel ));
+		mode_ptr = the_modes;
+		strcpy( the_args, "" );
+		while( *mode_ptr )
+		{
+			switch( *mode_ptr )
+			{
+				case 'l':
+					snprintf( argadd, sizeof( argadd ), " %ld", Channel_MaxUsers( Channel ));
+					strcat( the_args, argadd );
+					break;
+				case 'k':
+					strcat( the_args, " " );
+					strcat( the_args, Channel_Key( Channel ));
+					break;
+			}
+			mode_ptr++;
+		}
+		if( the_args[0] ) strcat( the_modes, the_args );
+
+		return IRC_WriteStrClient( Origin, RPL_CHANNELMODEIS_MSG, Client_ID( Origin ), Channel_Name( Channel ), the_modes );
+	}
 
 	/* Is the user allowed to change modes? */
 	if( Client_Type( Client ) == CLIENT_USER )
 	{
+		/* Is the originating user on that channel? */
+		if( ! Channel_IsMemberOf( Channel, Origin )) return IRC_WriteStrClient( Origin, ERR_NOTONCHANNEL_MSG, Client_ID( Origin ), Channel_Name( Channel ));
+
+		/* Is he channel operator? */
 		if( strchr( Channel_UserModes( Channel, Origin ), 'o' )) modeok = TRUE;
 		else modeok = FALSE;
 		if( Conf_OperCanMode )
@@ -472,6 +507,13 @@
 		/* Is there a valid mode change? */
 		if( ! x[0] ) continue;
 
+		/* Validate target client */
+		if( client && ( ! Channel_IsMemberOf( Channel, client )))
+		{
+			if( ! IRC_WriteStrClient( Origin, ERR_USERNOTINCHANNEL_MSG, Client_ID( Origin ), Client_ID( client ), Channel_Name( Channel ))) break;
+			continue;
+		}
+
 		if( set )
 		{
 			/* Set mode */
@@ -569,13 +611,14 @@
 	{
 		/* AWAY setzen */
 		Client_SetAway( Client, Req->argv[0] );
+		Client_ModeAdd( Client, 'a' );
 		IRC_WriteStrServersPrefix( Client, Client, "MODE %s :+a", Client_ID( Client ));
 		return IRC_WriteStrClient( Client, RPL_NOWAWAY_MSG, Client_ID( Client ));
 	}
 	else
 	{
 		/* AWAY loeschen */
-		Client_SetAway( Client, NULL );
+		Client_ModeDel( Client, 'a' );
 		IRC_WriteStrServersPrefix( Client, Client, "MODE %s :-a", Client_ID( Client ));
 		return IRC_WriteStrClient( Client, RPL_UNAWAY_MSG, Client_ID( Client ));
 	}
Index: src/ngircd/irc.c
===================================================================
RCS file: /usr/local/CVS/ngircd/ngircd/src/ngircd/irc.c,v
retrieving revision 1.107
retrieving revision 1.107.2.3
diff -u -r1.107 -r1.107.2.3
--- src/ngircd/irc.c	12 Dec 2002 12:24:18 -0000	1.107
+++ src/ngircd/irc.c	31 Dec 2002 15:48:33 -0000	1.107.2.3
@@ -14,7 +14,7 @@
 
 #include "portab.h"
 
-static char UNUSED id[] = "$Id: irc.c,v 1.107 2002/12/12 12:24:18 alex Exp $";
+static char UNUSED id[] = "$Id: irc.c,v 1.107.2.3 2002/12/31 15:48:33 alex Exp $";
 
 #include "imp.h"
 #include <assert.h>
@@ -52,14 +52,15 @@
 {
 	CLIENT *prefix, *c;
 	CHAR reason[COMMAND_LEN];
+	CONN_ID my_conn, conn;
 
 	assert( Client != NULL );
 	assert( Req != NULL );
 
-	/* is the user an IRC operator? */
+	/* Is the user an IRC operator? */
 	if(( Client_Type( Client ) != CLIENT_SERVER ) && ( ! Client_OperByMe( Client ))) return IRC_WriteStrClient( Client, ERR_NOPRIVILEGES_MSG, Client_ID( Client ));
 
-	/* Falsche Anzahl Parameter? */
+	/* Bad number of parameters? */
 	if(( Req->argc != 2 )) return IRC_WriteStrClient( Client, ERR_NEEDMOREPARAMS_MSG, Client_ID( Client ), Req->command );
 
 	if( Req->prefix ) prefix = Client_Search( Req->prefix );
@@ -72,24 +73,30 @@
 
 	Log( LOG_NOTICE|LOG_snotice, "Got KILL command from \"%s\" for \"%s\": %s", Client_Mask( prefix ), Req->argv[0], Req->argv[1] );
 
-	/* build reason string */
+	/* Build reason string */
 	if( Client_Type( Client ) == CLIENT_USER ) sprintf( reason, "KILLed by %s: %s", Client_ID( Client ), Req->argv[1] );
 	else strcpy( reason, Req->argv[1] );
 
-	/* andere Server benachrichtigen */
+	/* Inform other servers */
 	IRC_WriteStrServersPrefix( Client, prefix, "KILL %s :%s", Req->argv[0], reason );
+	
+	/* Save ID of this connection */
+	my_conn = Client_Conn( Client );
 
-	/* haben wir selber einen solchen Client? */
+	/* Do we host such a client? */
 	c = Client_Search( Req->argv[0] );
-	if( c )
+	if( c && Client_Type( c ) == CLIENT_USER )
 	{
-		/* Ja, wir haben einen solchen Client */
-		if( Client_Conn( c ) != NONE ) Conn_Close( Client_Conn( c ), NULL, reason, TRUE );
-		else Client_Destroy( c, NULL, reason, TRUE );
+		/* Yes, I found it! */
+		conn = Client_Conn( c );
+		Client_Destroy( c, NULL, reason, FALSE );
+		if( conn != NONE ) Conn_Close( Client_Conn( c ), NULL, reason, TRUE );
 	}
 	else Log( LOG_NOTICE, "Client with nick \"%s\" is unknown here.", Req->argv[0] );
 
-	return CONNECTED;
+	/* Are we still connected or were we killed, too? */
+	if( Client_GetFromConn( my_conn )) return CONNECTED;
+	else return DISCONNECTED;
 } /* IRC_KILL */
 
 
Index: src/ngircd/ngircd.c
===================================================================
RCS file: /usr/local/CVS/ngircd/ngircd/src/ngircd/ngircd.c,v
retrieving revision 1.64
retrieving revision 1.64.2.1
diff -u -r1.64 -r1.64.2.1
--- src/ngircd/ngircd.c	12 Dec 2002 11:31:21 -0000	1.64
+++ src/ngircd/ngircd.c	1 Jan 2003 13:47:42 -0000	1.64.2.1
@@ -1,6 +1,6 @@
 /*
  * ngIRCd -- The Next Generation IRC Daemon
- * Copyright (c)2001,2002 by Alexander Barton (alex@barton.de)
+ * Copyright (c)2001-2003 by Alexander Barton (alex@barton.de)
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
@@ -14,7 +14,7 @@
 
 #include "portab.h"
 
-static char UNUSED id[] = "$Id: ngircd.c,v 1.64 2002/12/12 11:31:21 alex Exp $";
+static char UNUSED id[] = "$Id: ngircd.c,v 1.64.2.1 2003/01/01 13:47:42 alex Exp $";
 
 #include "imp.h"
 #include <assert.h>
@@ -506,7 +506,7 @@
 Show_Version( VOID )
 {
 	puts( NGIRCd_Version( ));
-	puts( "Copyright (c)2001,2002 by Alexander Barton (<alex@barton.de>)." );
+	puts( "Copyright (c)2001-2003 by Alexander Barton (<alex@barton.de>)." );
 	puts( "Homepage: <http://arthur.ath.cx/~alex/ngircd/>\n" );
 	puts( "This is free software; see the source for copying conditions. There is NO" );
 	puts( "warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE." );
